/**
 *******************************************************************************
 * @file    i2c_slaveinterrupt.c
 *
 * @brief   Implement system specific functions.
 *
 * @author  DP
 *
 * @version V1.0.1
 *
 * @date    2024-11-11
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "i2c_slaveinterrupt.h"

/**
  * @addtogroup DPM32M036_LibSamples
  * @{
  */

/**
  * @addtogroup I2C
  * @{
  */

/**
  * @addtogroup I2C SlaveInterrupt
  * @{
  */

/* Private typedef --------------------------------------------------------------*/
I2C_InitTypeStruct I2C_InitStruct;

/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/
uint8_t  int_flag_cnt_rxne = 0;
uint8_t  int_flag_cnt_txe = 0;
uint8_t  int_flag_cnt_stop = 0;
uint8_t  int_flag_cnt_start = 0;
uint8_t  int_flag_cnt_match = 0;
uint8_t tx_buf[5] = {0x11, 0x22, 0x44, 0x88, 0xAA};
uint8_t rx_buf[5] ;

/* Private functions ------------------------------------------------------------*/
/**
 *******************************************************************************
 * @brief   I2C IRQ Handler.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void I2C_IRQ_Handler(void)
{
  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_STARTF) != RESET)
  {
    I2C_ClearIntFlag(I2C_INT_FLAG_STARTF);
    int_flag_cnt_start ++;
  }

  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_STOPF) != RESET)
  {
    I2C_ClearIntFlag(I2C_INT_FLAG_STOPF);
    int_flag_cnt_stop ++;
  }

  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_TXE) != RESET)
  {
    if(int_flag_cnt_txe < 5)
    {
      I2C_SendData(tx_buf[int_flag_cnt_txe]);
    }

    int_flag_cnt_txe++;
    I2C_ClearIntFlag(I2C_INT_FLAG_TXE);
  }

  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_RXNE) != RESET)
  {
    if(int_flag_cnt_rxne < 5)
    {
      rx_buf[int_flag_cnt_rxne] = I2C_ReceiveData();
    }

    int_flag_cnt_rxne++;
    I2C_ClearIntFlag(I2C_INT_FLAG_RXNE);
  }
  
  if(I2C_GetIntFlagStatus(I2C_INT_FLAG_ADDRM) != RESET)
  {
    I2C_ClearIntFlag(I2C_INT_FLAG_ADDRM);
    int_flag_cnt_match++;
  }
}

/**
 *******************************************************************************
 * @brief   I2C GPIO Init.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void I2C_GPIOInit(void)
{
  RCC_Unlock();
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  RCC_Lock();
  /* Cofig I2C GPIO */
  GPIO_InitTypeStruct GPIO_InitStruct;
  GPIO_StructInit(&GPIO_InitStruct);
  GPIO_InitStruct.GPIO_Mode = GPIO_MODE_ALT_FUNC;
  GPIO_InitStruct.GPIO_Speed = GPIO_SPEED_HIGH;
  GPIO_InitStruct.GPIO_OType = GPIO_OTYPE_OD;
  GPIO_InitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;
  GPIO_InitStruct.GPIO_Pin = GPIO_PIN_11 | GPIO_PIN_12;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_AltFuncConfig(GPIOA,GPIO_PIN_11, GPIO_ALT_FUNC_5);
  GPIO_AltFuncConfig(GPIOA,GPIO_PIN_12, GPIO_ALT_FUNC_5);
}
/**
 *******************************************************************************
 * @brief   I2C Config.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void I2C_Config(void)
{
  RCC_Unlock();
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_I2C, ENABLE);
  RCC_Lock();
  /* Config I2C */
  I2C_StructInit(&I2C_InitStruct);
  I2C_InitStruct.I2C_OwnAddress = 0x00;
  I2C_InitStruct.I2C_Prescaler = 0x16;
  I2C_InitStruct.I2C_Timing = 0x00420F13;
  I2C_InitStruct.I2C_DigitalFilter = 0x0F;
  I2C_InitStruct.I2C_Mode = I2C_MODE_SLAVE;
  I2C_InitStruct.I2C_AddressingMode = I2C_ADDRESSING_MODE_7BIT;
  I2C_Init(&I2C_InitStruct);
  /* Enable I2C */
  I2C_Cmd(ENABLE);
}
/**
 *******************************************************************************
 * @brief   I2C receive.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void I2C_ReceiveConfig(void)
{
  uint32_t time = GetTick() + 1000;

  /* Enable interrupt */
  NVIC_SetPriority(I2C_IRQn, 2);
  NVIC_EnableIRQ(I2C_IRQn);
  I2C_IntCmd(I2C_INT_TYPE_TXE, ENABLE);
  I2C_IntCmd(I2C_INT_TYPE_ADDRM, ENABLE);
  I2C_IntCmd(I2C_INT_TYPE_STOPF, ENABLE);
  I2C_IntCmd(I2C_INT_TYPE_START, ENABLE);

  int_flag_cnt_rxne = 0;
  int_flag_cnt_txe = 0;
  int_flag_cnt_stop = 0;
  int_flag_cnt_start = 0;
  int_flag_cnt_match = 0;

  /* Wait address match */
  while((int_flag_cnt_match < 1 || int_flag_cnt_start == 0) && (time > GetTick()));

  /* Send 5 byte data */
  while(int_flag_cnt_txe < 5 && (time > GetTick()));

  /* Wait stop */
  while(int_flag_cnt_stop == 0 && (time > GetTick()));
}
/**
 *******************************************************************************
 * @brief   I2C transmit.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void I2C_TransmitConfig(void)
{
  uint32_t time = GetTick() + 1000;

  I2C_IntCmd(I2C_INT_TYPE_RXNE, ENABLE);
  I2C_IntCmd(I2C_INT_TYPE_ADDRM, ENABLE);
  I2C_IntCmd(I2C_INT_TYPE_STOPF, ENABLE);
  I2C_IntCmd(I2C_INT_TYPE_START, ENABLE);

  int_flag_cnt_rxne = 0;
  int_flag_cnt_txe = 0;
  int_flag_cnt_stop = 0;
  int_flag_cnt_start = 0;
  int_flag_cnt_match = 0;

  /* Wait address match */
  while((int_flag_cnt_match == 0 || int_flag_cnt_start == 0) && (time > GetTick()));

  /* Receive 5 byte data */
  while(int_flag_cnt_rxne < 5 && (time > GetTick()));

  /* Wait stop */
  while(int_flag_cnt_stop == 0 && (time > GetTick()));
}
/**
 *******************************************************************************
 * @brief   I2C SlaveInterrupt Sample.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void I2C_SlaveInterrupt_Sample(void)
{
  /* GPIO init */
  I2C_GPIOInit();

  /* I2C config */
  I2C_Config();
  
  /* I2C receive */
  I2C_ReceiveConfig();
  
  /* I2C transmit */
  I2C_TransmitConfig();
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
